//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include<iostream.h>
#include "eval.h"
#include "Activate.h"
#include "password.h"
#include "EnumServer.h"
#include "GetKeyInfo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

RB_SPRO_APIPACKET ApiPacket;
RB_WORD DevID;
RB_WORD WritePW;
RB_WORD OverwritePW1;
RB_WORD OverwritePW2;
RB_WORD ActivatePW1;
RB_WORD ActivatePW2;
RB_WORD Valid_WritePW=0;
RB_WORD Valid_OWritePW=0;
BOOL bOk;

char szStatusStr[100];//the status string

TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//----------------------------------------------------------------------

void __fastcall TMainForm::FormActivate(TObject *Sender)
{

  char szTemp[50];
  SP_STATUS status;

  StatusEdit->SetTextBuf("");
  status = RNBOsproFormatPacket(&ApiPacket, sizeof(ApiPacket));
  if(status != 0)
  {
    sprintf(szTemp, "FormatPacket failed!\nReturn Code is: %d", status);
    MessageBox(NULL, szTemp, "FormatPacket", MB_OK | MB_TASKMODAL );
  }
  ComboBoxProtocolFlag->ItemIndex=0;
//  ClearInputs();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FindFirstBtnClick(TObject *Sender)
{

    SP_STATUS status;
    char szInput[10];
    RB_WORD devID;

    InputEdit->GetTextBuf(szInput, 6);
    if(!strcmp(szInput, ""))
    {
      MessageBox(NULL, "Specify Developer ID in the Input box to proceed.", "FindFirstUnit", MB_OK | MB_TASKMODAL );
      return;
    }
    if (ValidateInput(szInput,&devID,"FindFirstUnit","Developer ID",MAX_CELL_DATA_LEN))
      return;

    FindFirstBtn->Cursor=crHourGlass;
    status = RNBOsproFindFirstUnit(&ApiPacket, devID);
    FindFirstBtn->Cursor=crDefault;
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
       ViewKey();
       sprintf(szStatusStr, "FindFirstUnit successful!");
       ClearInputs();
    }
    else
       sprintf(szStatusStr, "FindFirstUnit failed!\nReturn code is %d.", status);
    StatusEdit->SetTextBuf(szStatusStr);
    OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FindNextBtnClick(TObject *Sender)
{

  SP_STATUS status;

  FindNextBtn->Cursor=crHourGlass;
  status = RNBOsproFindNextUnit(&ApiPacket);
  FindNextBtn->Cursor=crDefault;

   memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
       ViewKey();
       sprintf(szStatusStr, "FindNextUnit successful!");
       ClearInputs();       
    }
    else
       sprintf(szStatusStr, "FindNextUnit failed!\nReturn code is %d.", status);
    StatusEdit->SetTextBuf(szStatusStr);


  OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ReadBtnClick(TObject *Sender)
{
    char szTemp[10];
    RB_WORD nCell;
    RB_WORD nData;
    SP_STATUS status;

    CellEdit->GetTextBuf(szTemp, 5);
    if(!strcmp(szTemp, ""))
       MessageBox(NULL, "Specify cell address to proceed.", "Read", MB_OK | MB_TASKMODAL );
    else
    {
        if (ValidateInput(szTemp,&nCell,"Read","Cell address",MAX_CELL_ADD_LEN))
            return;
        status = RNBOsproRead(&ApiPacket, nCell, &nData);
        memset(szStatusStr,0,sizeof(szStatusStr));
        if(status == SP_SUCCESS)
        {
          sprintf(szTemp, "%04x", nData);
          OutputEdit->Text = szTemp;
          sprintf(szStatusStr, "Read successful!");
          CellEdit->Text = "";
          AccessEdit->Text = "";          
        }
        else
        {
          OutputEdit->Text = "";
          sprintf(szStatusStr, "Read failed!\nReturn code is %d.", status);
        }
        StatusEdit->SetTextBuf(szStatusStr);
  //      AccessEdit->Text = "";
    //    InputEdit->Text = "";
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::XReadBtnClick(TObject *Sender)
{
  char szTemp[10];
  RB_WORD nCell;
  RB_WORD nData;
  RB_BYTE nAccessCode;
  SP_STATUS status;

  CellEdit->GetTextBuf(szTemp, 5);
  if(!strcmp(szTemp, ""))
    MessageBox(NULL, "Specify cell address to proceed.", "ExtendedRead",  MB_OK | MB_TASKMODAL );
  else
  {
    if (ValidateInput(szTemp,&nCell,"ExtendedRead","Cell address",MAX_CELL_ADD_LEN))
        return;
    status = RNBOsproExtendedRead(&ApiPacket, nCell, &nData, &nAccessCode);
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
       sprintf(szTemp, "%04x", nData);
       OutputEdit->Text = szTemp;
       AccessEdit->Text = nAccessCode;
       sprintf(szStatusStr, "ExtendedRead successful!");
       CellEdit->Text = "";
     }
     else
     {
        OutputEdit->Text = "";
        AccessEdit->Text = "";
        sprintf(szStatusStr, "ExtendedRead failed!\nReturn code is %d.", status);
      }
      StatusEdit->SetTextBuf(szStatusStr);
      //InputEdit->Text = "";
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::WriteBtnClick(TObject *Sender)
{
  char szCell[10];
  char szInput[10];
  char szAccess[5];
  static RB_WORD nCell;
  static RB_WORD nData;
  static RB_BYTE nAccess;
  SP_STATUS status;

  CellEdit->GetTextBuf(szCell, 5);
  InputEdit->GetTextBuf(szInput, 6);
  AccessEdit->GetTextBuf(szAccess, 5);

  if(WritePW == 0)
  {
    MessageBox(NULL, "Specify Write password using passwords button to proceed.", "Write", MB_OK | MB_TASKMODAL );
    return;
  }

  if(!strcmp(szCell, ""))
  {
    MessageBox(NULL, "Specify cell address to proceed.", "Write", MB_OK | MB_TASKMODAL );
    return;
  }
  if (ValidateInput(szCell,&nCell,"Write","Cell address",MAX_CELL_ADD_LEN))
      return;

  if(!strcmp(szInput, ""))
  {
    MessageBox(NULL, "Specify data to be written in the input box to proceed.", "Write", MB_OK | MB_TASKMODAL );
    return;
  }
  if (ValidateInput(szInput,&nData,"Write","Cell data",MAX_CELL_DATA_LEN))
     return;

  if(!strcmp(szAccess, ""))
  {
    MessageBox(NULL, "Specify an access code to proceed.", "Write", MB_OK | MB_TASKMODAL );
    return;
  }
  if((strcmp(szAccess, "0"))&&(strcmp(szAccess, "1"))&&(strcmp(szAccess, "2"))&&(strcmp(szAccess, "3")))
  {
      MessageBox(NULL, "Access code must be between 0 and 3.","Write", MB_OK | MB_TASKMODAL );
      return;
  }


  if (ValidateAccessCode(szAccess,&nAccess,"Write"))
     return;  //access code must be restricted for a val b/w 0 and 3

  status = RNBOsproWrite(&ApiPacket, WritePW, nCell, nData, nAccess);
  memset(szStatusStr,0,sizeof(szStatusStr));
  if(status == SP_SUCCESS)
  {
      sprintf(szStatusStr, "Write successful!");
      ClearInputs();
  }
  else
      sprintf(szStatusStr, "Write failed!\nReturn code is %d.", status);
  StatusEdit->SetTextBuf(szStatusStr);
  OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::OverwriteBtnClick(TObject *Sender)
{
  char szCell[10];
  RB_WORD nCell;
  char szInput[10];
  RB_WORD nData;
  char szAccess[6];
  SP_STATUS status;
  RB_BYTE nAccess;


  if((OverwritePW1 == 0)||(OverwritePW2 == 0)||(WritePW == 0)  )
  {
    MessageBox(NULL, "Specify Write and Overwrite password(s) using passwords button to proceed.", "Overwrite", MB_OK | MB_TASKMODAL );
    return;
  }
  CellEdit->GetTextBuf(szCell, 6);
  InputEdit->GetTextBuf(szInput, 6);
  AccessEdit->GetTextBuf(szAccess, 6);

  if(!strcmp(szCell, ""))
  {
    MessageBox(NULL, "Specify cell address to proceed.", "Overwrite", MB_OK | MB_TASKMODAL );
    return;
  }
  if (ValidateInput(szCell,&nCell,"Overwrite","Cell address",MAX_CELL_ADD_LEN))
    return;

  if(!strcmp(szAccess, ""))
  {
    MessageBox(NULL, "Specify access code to proceed.", "Overwrite", MB_OK | MB_TASKMODAL );
    return;
  }

  if((strcmp(szAccess, "0"))&&(strcmp(szAccess, "1"))&&(strcmp(szAccess, "2"))&&(strcmp(szAccess, "3")))
  {
      MessageBox(NULL, "Access code must be between 0 and 3.","Write", MB_OK | MB_TASKMODAL );
      return;
  }

  if (ValidateAccessCode(szAccess,&nAccess,"Overwrite"))
      return;  //access code must be restricted for a val b/w 0 and 3

  if(!strcmp(szInput, ""))
  {
    MessageBox(NULL, "Specify data to be written in the input box to proceed.", "Overwrite", MB_OK | MB_TASKMODAL );
    return;
  }
  if (ValidateInput(szInput,&nData,"Overwrite","Cell data",MAX_CELL_DATA_LEN))
    return;

   status = RNBOsproOverwrite(&ApiPacket, WritePW, OverwritePW1, OverwritePW2, nCell, nData, nAccess);
   memset(szStatusStr,0,sizeof(szStatusStr));
   if(status == SP_SUCCESS)
    {
      sprintf(szStatusStr, "Overwrite successful!");
      ClearInputs();
    }
    else
      sprintf(szStatusStr, "Overwrite failed!\nReturn code is %d.", status);
    StatusEdit->SetTextBuf(szStatusStr);
    OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::QueryBtnClick(TObject *Sender)
{
                       char szTemp[10];
  char szHexResponse[SPRO_MAX_QUERY_SIZE*2 + 1];
  char szQuery[SPRO_MAX_QUERY_SIZE*2 + 1];
  static char szQueryData[SPRO_MAX_QUERY_SIZE*2 + 1];
  static char szQueryResponse[SPRO_MAX_QUERY_SIZE*2 + 1];
  static RB_WORD nCell;
  static RB_DWORD nResponse32;
  static RB_WORD nQueryLen;
  SP_STATUS status;
  int len;

  CellEdit->GetTextBuf(szTemp, 5);
  if(!strcmp(szTemp, ""))
  {
    MessageBox(NULL, "Specify cell address to proceed.", "Query", MB_OK | MB_TASKMODAL );
    return;
  }
  if (ValidateInput(szTemp,&nCell,"Query","Cell address",MAX_CELL_ADD_LEN))
    return;

  InputEdit->GetTextBuf(szQuery, SPRO_MAX_QUERY_SIZE*2+10);
  if(!strcmp(szQuery, ""))
  {
    MessageBox(NULL, "Specify query data in the input box to proceed.", "Query", MB_OK | MB_TASKMODAL );
    return;
  }
  len = strlen(szQuery);
  if(((len < 8)||(len > SPRO_MAX_QUERY_SIZE * 2)) ||(len % 2 != 0) )
  {
    sprintf(szStatusStr, "Query data must be in hex. The length of string must be even and between 8 to %d.",SPRO_MAX_QUERY_SIZE*2);
    MessageBox(NULL, szStatusStr, "Query", MB_OK | MB_TASKMODAL );
    return;
  }
  if (ValidateInput(szQuery,NULL,"Query","",SPRO_MAX_QUERY_SIZE*2))
    return;
  else
  {
    PackQueryData(szQuery, szQueryData);
    nQueryLen = (RB_WORD)strlen(szQueryData);
    status = RNBOsproQuery(&ApiPacket, nCell, szQueryData, szQueryResponse, &nResponse32, nQueryLen);
    UnpackResult(szQueryResponse, szHexResponse, nQueryLen);
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
      sprintf(szStatusStr, "Query successful!");
      OutputEdit->Text = szHexResponse;
      ClearInputs();
    }
    else
    {
      sprintf(szStatusStr, "Query failed!\nReturn code is %d.", status);
      OutputEdit->Text = "";
    }
    StatusEdit->SetTextBuf(szStatusStr);

  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PackQueryData(char szQuery[], char *szQueryData)
{
  int nLength;
  int i,j=0;
  char c;

  strcpy(szQueryData, "");
  nLength = strlen(szQuery)/2;

  /* pack the query string */
  for(i=0; i<nLength; i++, j+=2)
  {
    if(szQuery[j] <'A')
       c =  (szQuery[j] & 0xf) << 4;
    else
       c = ((szQuery[j] & 0xf) + 9) << 4;
    if(szQuery[j+1] < 'A')
       c += szQuery[j+1] & 0xf;
    else
       c += (szQuery[j+1] & 0xf) +9;
    szQueryData[i] = c;
  }

  szQueryData[nLength] = 0;
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::UnpackResult(char szResult[], char *szHexResponse, int nLength)
{
  char szTemp[] = "0123456789ABCDEF";
  int nTemp, nTemp2;
  int j=0;

  for(int i=0; i<nLength; i++)
  {
    nTemp = (szResult[i] >> 4) & 0xf;
    nTemp2 = szResult[i] & 0xf;

    szHexResponse[j] = szTemp[nTemp];
    szHexResponse[j+1] = szTemp[nTemp2];
    j = j + 2;
  }
  szHexResponse[j] = 0;
}

//---------------------------------------------------------------------------


void __fastcall TMainForm::DecrementBtnClick(TObject *Sender)
{
  char szCell[10];
  static RB_WORD nCell;
  SP_STATUS status;

  if(WritePW == 0)
  {
    MessageBox(NULL, "Specify Write password using passwords button to proceed.", "Decrement", MB_OK | MB_TASKMODAL );
    return;
  }

  CellEdit->GetTextBuf(szCell, 5);

  if(!strcmp(szCell, ""))
    MessageBox(NULL, "Specify cell address to proceed.", "Decrement", MB_OK | MB_TASKMODAL );
  else
  {
    if (ValidateInput(szCell,&nCell,"Decrement","Cell address",MAX_CELL_ADD_LEN))
      return;
    status = RNBOsproDecrement(&ApiPacket, WritePW, nCell);
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
      ClearInputs();
      sprintf(szStatusStr, "Decrement successful!");
    }
    else
      sprintf(szStatusStr, "Decrement failed!\nReturn code is %d.", status);
    StatusEdit->SetTextBuf(szStatusStr);
//    AccessEdit->Text = "";
  //  InputEdit->Text = "";
    OutputEdit->Text = "";
  }

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StatusBtnClick(TObject *Sender)
{
  SP_STATUS status;

  status = RNBOsproGetFullStatus(&ApiPacket);
  memset(szStatusStr,0,sizeof(szStatusStr));
  sprintf(szStatusStr, "GetFullStatus successful!\nStatus of last API called is %d.", status);
  StatusEdit->SetTextBuf(szStatusStr);
  ClearInputs();
  OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::VersionBtnClick(TObject *Sender)
{
  SP_STATUS status;
  RB_BYTE nMajVer;
  RB_BYTE nMinVer;
  RB_BYTE nRevision;
  RB_BYTE nDriverType;
  char szTemp[100];
  
  status = RNBOsproGetVersion(&ApiPacket, &nMajVer, &nMinVer, &nRevision, &nDriverType);
  memset(szStatusStr,0,sizeof(szStatusStr));
  if(status == SP_SUCCESS)
  {
    switch(nDriverType)
    {
      case RB_WINNT_SYS_DRVR:
        sprintf(szStatusStr, "GetVersion successful!\nMajor version: %d\nMinor version: %d\nRevision: %d\nOS Driver Type: %d (Windows NT system driver)", nMajVer, nMinVer, nRevision, nDriverType);
        break;
      case RB_WIN95_SYS_DRVR:
        sprintf(szStatusStr, "GetVersion successful!\nMajor version: %d\nMinor version: %d\nRevision: %d\nOS Driver Type: %d (Windows 95 system driver)", nMajVer, nMinVer, nRevision, nDriverType);
        break;
      case RB_NW_LOCAL_DRVR:
        sprintf(szStatusStr, "GetVersion successful!\nMajor version: %d\nMinor version: %d\nOS Driver Type: %d (Novell system driver)", nMajVer, nMinVer, nRevision, nDriverType);
        break;
      default://unknown driver type
        sprintf(szStatusStr, "GetVersion successful!\nMajor version: %d\nMinor version: %d\nRevision: %d\nOS Driver Type: %d.", nMajVer, nMinVer, nRevision, nDriverType);
        break;
    }
    ClearInputs();
  }
  else
      sprintf(szStatusStr, "GetVersion failed!\nReturn code is %d.", status);
  StatusEdit->SetTextBuf(szStatusStr);

  OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ViewBtnClick(TObject *Sender)
{
    ViewKey();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ExitBtnClick(TObject *Sender)
{
    RNBOsproReleaseLicense(&ApiPacket,0,NULL);
    Close();
}
//---------------------------------------------------------------------------
 void __fastcall TMainForm::ViewKey()
{
  RB_WORD nData;
  RB_WORD i;
  SP_STATUS status;
  char szTemp[10];
  TEdit *EditArray[] = {Edit1, Edit2, Edit3, Edit4, Edit5, Edit6,
                        Edit7, Edit8, Edit9, Edit10, Edit11, Edit12,
                        Edit13, Edit14, Edit15, Edit16, Edit17, Edit18,
                        Edit19, Edit20, Edit21, Edit22, Edit23, Edit24,
                        Edit25, Edit26, Edit27, Edit28, Edit29, Edit30,
                        Edit31, Edit32, Edit33, Edit34, Edit35, Edit36,
                        Edit37, Edit38, Edit39, Edit40, Edit41, Edit42,
                        Edit43, Edit44, Edit45, Edit46, Edit47, Edit48,
                        Edit49, Edit50, Edit51, Edit52, Edit53, Edit54,
                        Edit55, Edit56, Edit57, Edit58, Edit59, Edit60,
                        Edit61, Edit62, Edit63, Edit64};

  for( i=0; i<64; i++)
  {
    status = RNBOsproRead(&ApiPacket, i, &nData);
    if(status == 0)
      sprintf(szTemp, "%04x", nData);
    else
      strcpy(szTemp, "????");
    EditArray[i]->Text = szTemp;
  }
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::SetContactBtnClick(TObject *Sender)
{
  SP_STATUS     status;
  char srvr[MAX_NAME_LEN+1];


  if(ServerName->Text.Length() >MAX_NAME_LEN - 1)
  {
    MessageBox(NULL, "ContactServer length must not exceed 63.",
                "SetContactServer", MB_OK | MB_TASKMODAL );
    return;
   }

   strcpy(srvr,ServerName->Text.c_str());
//  status=RNBOsproSetContactServer (&ApiPacket, InputEdit->Text.c_str());
  status=RNBOsproSetContactServer (&ApiPacket, srvr);
  memset(szStatusStr,0,sizeof(szStatusStr));
  if(status == SP_SUCCESS)
  {
      sprintf(szStatusStr, "SetContactServer successful!");
      ClearInputs();
  }
  else
      sprintf(szStatusStr, "SetContactServer failed!\nReturn code is %d.", status);
  StatusEdit->SetTextBuf(szStatusStr);
  OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::GetContactBtnClick(TObject *Sender)
{
  char          szTemp[256];
  SP_STATUS     status;

  status=RNBOsproGetContactServer (&ApiPacket, (char *)&szTemp, 256);
  memset(szStatusStr,0,sizeof(szStatusStr));
  if(status == SP_SUCCESS)
  {
      sprintf(szStatusStr, "GetContactServer successful!");
      OutputEdit->Text=szTemp;
      ClearInputs();
  }
  else
  {
      sprintf(szStatusStr, "GetContactServer failed!\nReturn code is %d.", status);
      OutputEdit->Text = "";
  }
  StatusEdit->SetTextBuf(szStatusStr);
  //CellEdit->Text = "";
  //AccessEdit->Text = "";
  //InputEdit->Text = "";

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ReleaseBtnClick(TObject *Sender)
{
    SP_STATUS   status;
    char szCell[10];
    RB_WORD     nCell;
    char  szNumRelease[10];
    RB_WORD  numRelease;
    CellEdit->GetTextBuf(szCell, 5);
    InputEdit->GetTextBuf(szNumRelease, 6);
    if(!strcmp(szCell, ""))
    {
        MessageBox(NULL, "Specify cell address to proceed.", "ReleaseLicence", MB_OK | MB_TASKMODAL );
        return;
    }
    if (ValidateInput(szCell,&nCell,"ReleaseLicence","Cell address",MAX_CELL_ADD_LEN))
      return;

    if (InputEdit->Text.IsEmpty()==true)  // default to 1 if empty
    {
       MessageBox(NULL,"Specify the number of sublicenses to release in the Input box to proceed.", "ReleaseLicense", MB_OK | MB_TASKMODAL );
       return;
    }

    if (ValidateNumSubLic(szNumRelease,&numRelease))
      return;

    //sscanf(szNumRelease, "%x", &numRelease);
    //sscanf(szCell, "%x", &nCell);
    status = RNBOsproReleaseLicense (&ApiPacket, nCell, &numRelease);
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
      OutputEdit->Text=IntToStr (numRelease);
      sprintf(szStatusStr, "ReleaseLicense successful!");
      ClearInputs();
    }
    else
    {
      OutputEdit->Text="";
      sprintf(szStatusStr, "ReleaseLicense failed!\nReturn code is %d.", status);
    }
    StatusEdit->SetTextBuf(szStatusStr);
//    AccessEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::GetSubBtnClick(TObject *Sender)
{
    SP_STATUS   status;
    char szCell[10];
    RB_WORD     nCell;// numLic;

    CellEdit->GetTextBuf(szCell, 5);
    if(!strcmp(szCell, ""))
    {
      MessageBox(NULL, "Specify cell address to proceed.", "GetSubLicense", MB_OK | MB_TASKMODAL );
      return;
    }
    if (ValidateInput(szCell,&nCell,"GetSubLicense","Cell address",MAX_CELL_ADD_LEN))
      return;

    status=RNBOsproGetSubLicense (&ApiPacket, nCell);
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
      sprintf(szStatusStr, "GetSubLicense successful!");
      ClearInputs();
    }
    else
      sprintf(szStatusStr, "GetSubLicense failed!\nReturn code is %d.", status);
    StatusEdit->SetTextBuf(szStatusStr);
    //AccessEdit->Text = "";
    //InputEdit->Text = "";
    OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PasswordsBtnClick(TObject *Sender)
{
    PasswordForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HardLimitBtnClick(TObject *Sender)
{
    SP_STATUS   status;
    RB_WORD hardlimit;

    status = RNBOsproGetHardLimit(&ApiPacket, &hardlimit);
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
      OutputEdit->Text = IntToStr (hardlimit);
      sprintf(szStatusStr, "GetHardLimit successful!");
      ClearInputs();
    }
    else
    {
      OutputEdit->Text = "";
      sprintf(szStatusStr, "GetHardLimit failed!\nReturn code is %d.", status);
    }
    StatusEdit->SetTextBuf(szStatusStr);
//    ClearInputs();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ActivateBtnClick(TObject *Sender)
{
  char szCell[10];
  static RB_WORD nCell;
  SP_STATUS status;

  if(WritePW == 0)
  {
    MessageBox(NULL, "Specify Write password using passwords button to proceed.", "Activate", MB_OK | MB_TASKMODAL );
    return;
  }

  CellEdit->GetTextBuf(szCell, 5);

  if(!strcmp(szCell, ""))
    MessageBox(NULL, "Specify cell address to proceed.", "Activate", MB_OK | MB_TASKMODAL );
  else
  {
    if (ValidateInput(szCell,&nCell,"Activate","Cell address",MAX_CELL_ADD_LEN))
         return;
    ActivateForm->ShowModal();
    if(bOk)
    {
      status = RNBOsproActivate(&ApiPacket, WritePW, ActivatePW1, ActivatePW2, nCell);
      memset(szStatusStr,0,sizeof(szStatusStr));
      if(status == SP_SUCCESS)
      {
        sprintf(szStatusStr, "Activate successful!");
        ClearInputs();
      }
      else
        sprintf(szStatusStr, "Activate failed!\nReturn code is %d.", status);
      StatusEdit->SetTextBuf(szStatusStr);
      OutputEdit->Text = "";
//      AccessEdit->Text = "";
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EnumServerBtnClick(TObject *Sender)
{
    EnumServerForm->ComboBoxEnumFlag->ItemIndex=0;    
    EnumServerForm->ShowModal();
}
//---------------------------------------------------------------------------




void __fastcall TMainForm::SetHeartBeatBtnClick(TObject *Sender)
{
    SP_STATUS status;
    int heartbeat;
    char szHbeat[10];

    if (InputEdit->Text.IsEmpty()==true)  // default to 1 if empty
        MessageBox(NULL, "Specify heartbeat value in input box to proceed.", "SetHeartBeat", MB_OK | MB_TASKMODAL );
    else
    {
       InputEdit->GetTextBuf(szHbeat,10);
       if (ValidateHeartBeat(szHbeat, &heartbeat))
           return;
       /*if(!strcmp(szHbeat,"FFFFFFFF"))
           sscanf(szHbeat,"%8x",&heartbeat);
       else
    	   heartbeat = atol(szHbeat);*/
       status = RNBOsproSetHeartBeat(&ApiPacket, heartbeat);
       memset(szStatusStr,0,sizeof(szStatusStr));
       if(status == SP_SUCCESS)
       {
         sprintf(szStatusStr, "SetHeartBeat successful!");
         ClearInputs();
       }
       else
         sprintf(szStatusStr, "SetHeartBeat failed!\nReturn code is %d.", status);
       StatusEdit->SetTextBuf(szStatusStr);
//       CellEdit->Text = "";
  //     AccessEdit->Text = "";
       OutputEdit->Text = "";
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SetProtocolBtnClick(TObject *Sender)
{
    SP_STATUS status;
    int ProtocolFlag;
    char szprotflag[30];

    ComboBoxProtocolFlag->GetTextBuf(szprotflag,30);
    if(!strcmp(szprotflag,""))
        MessageBox(NULL, "Select a protocol to proceed.", "SetProtocol", MB_OK | MB_TASKMODAL );
    else
     {
        if(!strcmp(szprotflag,"NSPRO_TCP_PROTOCOL"))
            ProtocolFlag = 1;
        else if (!strcmp(szprotflag,"NSPRO_IPX_PROTOCOL"))
            ProtocolFlag = 2;
        else if (!strcmp(szprotflag,"NSPRO_NETBEUI_PROTOCOL"))
            ProtocolFlag= 4;
        else if (!strcmp(szprotflag,"NSPRO_SAP_PROTOCOL"))
            ProtocolFlag = 8;//SAP
        else
        {
           MessageBox(NULL, "Select a protocol to proceed.", "SetProtocol", MB_OK | MB_TASKMODAL );
           return;
        }

        status = RNBOsproSetProtocol(&ApiPacket, ProtocolFlag);
        memset(szStatusStr,0,sizeof(szStatusStr));
        if(status == SP_SUCCESS)
        {
          sprintf(szStatusStr, "SetProtocol successful!");
          ClearInputs();
        }
        else
          sprintf(szStatusStr, "SetProtocol failed!\nReturn code is %d.", status);
        StatusEdit->SetTextBuf(szStatusStr);
        OutputEdit->Text = "";
     }
}
//---------------------------------------------------------------------------




void __fastcall TMainForm::InitBtnClick(TObject *Sender)
{
    SP_STATUS status;
    status = RNBOsproInitialize(&ApiPacket);
    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
      sprintf(szStatusStr, "Initialize successful!");
      ClearInputs();
    }
    else
      sprintf(szStatusStr, "Initialize failed!\nReturn code is %d.", status);
    StatusEdit->SetTextBuf(szStatusStr);
    OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormatPktBtnClick(TObject *Sender)
{
    SP_STATUS status;

    status = RNBOsproFormatPacket(&ApiPacket,sizeof(ApiPacket));

    memset(szStatusStr,0,sizeof(szStatusStr));
    if(status == SP_SUCCESS)
    {
       sprintf(szStatusStr, "FormatPacket successful!");
       ClearInputs();
    }
    else
       sprintf(szStatusStr, "FormatPacket failed! Return code is %d.", status);
    StatusEdit->SetTextBuf(szStatusStr);
    OutputEdit->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::GetKeyInfoBtnClick(TObject *Sender)
{
//initialize the GetKeyInfoForm edit boxes
    FrmGetKeyInfo->txtDevId->SetTextBuf("FFFF");
    FrmGetKeyInfo->txtHrdLmt->SetTextBuf("");
    FrmGetKeyInfo->txtLicInUse->SetTextBuf("");
    FrmGetKeyInfo->txtTmOut->SetTextBuf("");
    FrmGetKeyInfo->txtHighestInUse->SetTextBuf("");
    FrmGetKeyInfo->ShowModal();
}
//---------------------------------------------------------------------------
/*this function will validate the input entered by the user
*/
int  __fastcall TMainForm::ValidateInput(char* input, RB_WORD* output,
                                char* titleStr,char* msgStr,int maxLen)
{
   char szTempStr[100], szTempInputStr[3];
   int retVal, inputStrLen,index, tempOutput;
   if(output)
    *output = 0;
   inputStrLen = strlen(input);
   for(index= 0; index<inputStrLen; index++)
   {
      memset(szTempInputStr,0,sizeof(szTempInputStr));
      sprintf(szTempInputStr, "%c",input[index]);
      retVal = sscanf(szTempInputStr,"%x",&tempOutput);
      if((retVal <= 0))
          break;
   }
   if ((inputStrLen > maxLen) || (retVal <= 0))
   {
      memset(szTempStr,0,sizeof(szTempStr));
      if(output)
          sprintf(szTempStr,"%s must be in hex with length not exceeding %d digits.",msgStr, maxLen);
      else//for query we pass output as NULL
          sprintf(szTempStr, "Query data must be in hex. The length of string must be even and between 8 to %d.",SPRO_MAX_QUERY_SIZE);
      MessageBox(NULL, szTempStr, titleStr, MB_OK | MB_TASKMODAL );
      return 1;
   }
   if(output)
      sscanf(input,"%x",output);
   return 0;
}

//---------------------------------------------------------------------------
/*this function will validate the accesscode entered by the user
*/
int  __fastcall TMainForm::ValidateAccessCode(char* input,
                                  RB_BYTE* accessCode,char* titleStr)
{
   char szTempStr[100], szTempInputStr[2];
   int retVal, inputStrLen,index, tempOutput;

   inputStrLen = strlen(input);
   for(index= 0; index<inputStrLen; index++)
   {
      memset(szTempInputStr,0,sizeof(szTempInputStr));
      sprintf(szTempInputStr, "%c",input[index]);
      retVal = sscanf(szTempInputStr,"%d.",&tempOutput);
      if(retVal == 0)
         break;
   }
   sscanf(input,"%x",accessCode);
   if ((retVal== 0)||((int)*accessCode < 0)||((int)*accessCode > MAX_ACCESS_CODE))
   {
      memset(szTempStr,0,sizeof(szTempStr));
      sprintf(szTempStr,"Access code must be between 0 and %d.", MAX_ACCESS_CODE);
      MessageBox(NULL, szTempStr, titleStr, MB_OK | MB_TASKMODAL );
      return 1;
   }

   return 0;
}

int  __fastcall TMainForm::ValidateHeartBeat(char* input,int* hBeat)
{
   char szTempStr[100], szTempInputStr[2];
   int retVal, inputStrLen,index, tempOutput;

   inputStrLen = strlen(input);
   for(index= 0; index<inputStrLen; index++)
   {
      memset(szTempInputStr,0,sizeof(szTempInputStr));
      sprintf(szTempInputStr, "%c",input[index]);
      retVal = sscanf(szTempInputStr,"%d.",&tempOutput);
      if(retVal == 0)
         break;
   }
   sscanf(input,"%d",hBeat);
   if ((retVal == 0)||((*hBeat != -1))&& ((*hBeat < MIN_HEARTBEAT)||(*hBeat > MAX_HEARTBEAT)))
   {
      memset(szTempStr,0,sizeof(szTempStr));
      sprintf(szTempStr,"HeartBeat must be an integer between %d and %d. Enter -1 for infinite heartbeat.",
      MIN_HEARTBEAT,MAX_HEARTBEAT);
      MessageBox(NULL, szTempStr, "SetHeartBeat", MB_OK | MB_TASKMODAL );
      return 1;
   }
   return 0;
}
/////////////////////////////////

int  __fastcall TMainForm::ValidateNumSubLic(char* input,RB_WORD* NumSubLic)
{
   char szTempStr[100], szTempInputStr[2];
   int retVal, inputStrLen,index, tempOutput;

   inputStrLen = strlen(input);
   if ( (atoi(input) < 0) || (atoi(input) > 65535) )
   {
      sprintf(szTempStr,"Number of sublicense(s) must be an integer between 0 to 65535.");
      MessageBox(NULL, szTempStr, "ReleaseLicense", MB_OK | MB_TASKMODAL );
      return 1;
   }
   for(index= 0; index < inputStrLen; index++)
   {
      memset(szTempInputStr,0,sizeof(szTempInputStr));
      sprintf(szTempInputStr, "%c",input[index]);
      retVal = sscanf(szTempInputStr,"%d.",&tempOutput);
      if(retVal == 0)
         break;
   }
   index = sscanf(input,"%d",NumSubLic);

   if((retVal == 0))
   {
      sprintf(szTempStr,"Number of sublicense(s) must be an integer between 0 to 65535.");
      MessageBox(NULL, szTempStr, "ReleaseLicense", MB_OK | MB_TASKMODAL );
      return 1;
   }
   return 0;
}
/////////////////////////////////

void __fastcall TMainForm::ClearInputs()
{
   CellEdit->Text = "";
   AccessEdit->Text = "";
   InputEdit->Text = "";
}

