//---------------------------------------------------------------------------
#ifndef evalH
#define evalH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "spromeps.h"
#include <ComCtrls.hpp>
#include <Graphics.hpp>

#define MAX_CELL_DATA_LEN 4
#define MAX_CELL_ADD_LEN  2
#define MAX_ACCESS_CODE   3




//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TPanel *Panel2;
    TPanel *Panel3;
    TPanel *Panel4;
    TPanel *Panel5;
    TPanel *Panel6;
    TPanel *Panel7;
    TPanel *Panel8;
    TPanel *Panel9;
    TPanel *Panel10;
    TPanel *Panel12;
    TPanel *Panel13;
    TPanel *Panel14;
    TPanel *Panel15;
    TPanel *Panel16;
    TPanel *Panel17;
    TPanel *Panel18;
    TPanel *Panel19;
    TPanel *Panel20;
    TPanel *Panel21;
    TPanel *Panel22;
    TEdit *Edit1;
    TEdit *Edit2;
    TEdit *Edit3;
    TEdit *Edit4;
    TEdit *Edit5;
    TEdit *Edit6;
    TEdit *Edit7;
    TEdit *Edit8;
    TEdit *Edit10;
    TEdit *Edit11;
    TEdit *Edit12;
    TEdit *Edit13;
    TEdit *Edit14;
    TEdit *Edit15;
    TEdit *Edit16;
    TEdit *Edit9;
    TEdit *Edit17;
    TEdit *Edit18;
    TEdit *Edit19;
    TEdit *Edit20;
    TEdit *Edit21;
    TEdit *Edit22;
    TEdit *Edit23;
    TEdit *Edit24;
    TEdit *Edit26;
    TEdit *Edit27;
    TEdit *Edit28;
    TEdit *Edit29;
    TEdit *Edit30;
    TEdit *Edit31;
    TEdit *Edit32;
    TEdit *Edit25;
    TEdit *Edit34;
    TEdit *Edit35;
    TEdit *Edit36;
    TEdit *Edit37;
    TEdit *Edit38;
    TEdit *Edit39;
    TEdit *Edit40;
    TEdit *Edit41;
    TEdit *Edit42;
    TEdit *Edit43;
    TEdit *Edit44;
    TEdit *Edit45;
    TEdit *Edit46;
    TEdit *Edit47;
    TEdit *Edit48;
    TEdit *Edit33;
    TEdit *Edit49;
    TEdit *Edit50;
    TEdit *Edit51;
    TEdit *Edit52;
    TEdit *Edit53;
    TEdit *Edit54;
    TEdit *Edit55;
    TEdit *Edit56;
    TEdit *Edit57;
    TEdit *Edit58;
    TEdit *Edit59;
    TEdit *Edit60;
    TEdit *Edit61;
    TEdit *Edit62;
    TEdit *Edit63;
    TEdit *Edit64;
    TGroupBox *GroupBox1;
    TButton *FindFirstBtn;
    TButton *FindNextBtn;
    TButton *ReadBtn;
    TButton *WriteBtn;
    TButton *OverwriteBtn;
    TButton *XReadBtn;
    TButton *QueryBtn;
    TButton *ActivateBtn;
    TButton *DecrementBtn;
    TButton *VersionBtn;
    TButton *StatusBtn;
    TButton *HardLimitBtn;
    TGroupBox *GroupBox2;
    TLabel *CellText;
    TEdit *CellEdit;
    TLabel *InputText;
    TEdit *InputEdit;
    TLabel *OutputText;
    TEdit *OutputEdit;
    TLabel *StatusText;
    TLabel *AccessText;
    TEdit *AccessEdit;
    TGroupBox *GroupBox4;
    TButton *ViewBtn;
    TButton *PasswordsBtn;
    TButton *SetProtocolBtn;
    TComboBox *ComboBoxProtocolFlag;
    TLabel *Label1;
    TButton *SetHeartBeatBtn;
    TButton *SetContactBtn;
    TButton *GetContactBtn;
    TButton *GetSubBtn;
    TButton *ReleaseBtn;
    TButton *EnumServerBtn;
    TButton *InitBtn;
    TButton *FormatPktBtn;
    TButton *GetKeyInfoBtn;
        TRichEdit *StatusEdit;
        TLabel *Label2;
        TLabel *Label3;
        TImage *Image1;
        TGroupBox *GroupBox3;
        TButton *ExitBtn;
        TComboBox *ServerName;
        TLabel *Label4;
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FindFirstBtnClick(TObject *Sender);
    void __fastcall FindNextBtnClick(TObject *Sender);
    void __fastcall ReadBtnClick(TObject *Sender);
    void __fastcall XReadBtnClick(TObject *Sender);
    void __fastcall WriteBtnClick(TObject *Sender);
    void __fastcall OverwriteBtnClick(TObject *Sender);
    void __fastcall QueryBtnClick(TObject *Sender);
    void __fastcall DecrementBtnClick(TObject *Sender);
    void __fastcall StatusBtnClick(TObject *Sender);
    void __fastcall VersionBtnClick(TObject *Sender);
    void __fastcall ViewBtnClick(TObject *Sender);
    void __fastcall ExitBtnClick(TObject *Sender);
    void __fastcall SetContactBtnClick(TObject *Sender);
    void __fastcall GetContactBtnClick(TObject *Sender);
    void __fastcall ReleaseBtnClick(TObject *Sender);
    void __fastcall GetSubBtnClick(TObject *Sender);
    void __fastcall PasswordsBtnClick(TObject *Sender);
    void __fastcall HardLimitBtnClick(TObject *Sender);
    void __fastcall ActivateBtnClick(TObject *Sender);
    void __fastcall ViewKey();
    void __fastcall UnpackResult(char szResult[], char *szHexResponse, int nLength);
    void __fastcall PackQueryData(char szQuery[], char *szQueryData);
    void __fastcall EnumServerBtnClick(TObject *Sender);



    void __fastcall SetHeartBeatBtnClick(TObject *Sender);
    void __fastcall SetProtocolBtnClick(TObject *Sender);



    void __fastcall InitBtnClick(TObject *Sender);
    void __fastcall FormatPktBtnClick(TObject *Sender);
    void __fastcall GetKeyInfoBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    void __fastcall ClearInputs();
    int  __fastcall ValidateInput(char* input, RB_WORD* output,
                                char* titleStr,char* msgStr,int maxLen);
    int  __fastcall ValidateAccessCode(char* input, RB_BYTE* accessCode,
                                char* titleStr);
    int  __fastcall TMainForm::ValidateHeartBeat(char* input,int* hBeat);
    int  __fastcall TMainForm::ValidateNumSubLic(char* input,RB_WORD* NumSubLic);                               

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
