//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "GetKeyInfo.h"
#include "spromeps.h"
#include "eval.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
extern RB_SPRO_APIPACKET ApiPacket;
TFrmGetKeyInfo *FrmGetKeyInfo;
int index = 1;// the keyindex parameter of the GetKeyInfo API

//---------------------------------------------------------------------------
__fastcall TFrmGetKeyInfo::TFrmGetKeyInfo(TComponent* Owner)
    : TForm(Owner)
{

}
//---------------------------------------------------------------------------

void __fastcall TFrmGetKeyInfo::btnExitClick(TObject *Sender)
{
    index = 1;
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TFrmGetKeyInfo::btnNextKeyClick(TObject *Sender)
{
   SP_STATUS status; // return Status of the API.
   char      szTempStr[50];
   RB_WORD   devId, timedOut, inUse, highestInUse, hrdLmt;
   NSPRO_MONITOR_INFO monInfo;
   char      szdevId[5], szHrdLmt[5], szInUse[5], szTmOut[5], szHighestInUse[5];
   char      msgKeyInfo[100];//this will store the KeyInfo.
   TMainForm* mainFrm;

   txtDevId->GetTextBuf(szdevId, 6);

   if(!strcmp(szdevId,""))
   {
      MessageBox(NULL, "Specify Developer ID to proceed.", "GetKeyInfo", MB_OK | MB_TASKMODAL );
      return;
   }
   if (mainFrm->ValidateInput(szdevId,&devId,"GetKeyInfo","Developer ID",MAX_CELL_DATA_LEN))
         return;

//   sscanf(szdevId, "%x", &devId);//extract the devid
   memset(msgKeyInfo,0,sizeof(msgKeyInfo));

   status = RNBOsproGetKeyInfo(&ApiPacket, devId, index ,&monInfo);//call the API
   if(status != SP_SUCCESS)//if API fails
   {
      sprintf(msgKeyInfo,"GetKeyInfo failed! Return code is %d.",status);
      MessageBox(NULL, msgKeyInfo, "GetKeyInfo", MB_OK | MB_TASKMODAL );
     // ClearTextBoxes();
   }
   else   //GetKeyInfo successful
   {
      index++; //increment the index for the next key
      memset(szdevId,0,sizeof(szdevId));
      memset(szHrdLmt,0,sizeof(szHrdLmt));
      memset(szInUse,0,sizeof(szInUse));
      memset(szTmOut,0,sizeof(szTmOut));
      memset(szHighestInUse,0,sizeof(szHighestInUse));

      sprintf(szdevId,"%x",monInfo.sproKeyMonitorInfo.devId);
      sprintf(szHrdLmt,"%d",monInfo.sproKeyMonitorInfo.hardLimit);
      sprintf(szInUse,"%d",monInfo.sproKeyMonitorInfo.inUse);
      sprintf(szTmOut,"%d",monInfo.sproKeyMonitorInfo.numTimeOut);
      sprintf(szHighestInUse,"%d",monInfo.sproKeyMonitorInfo.highestUse);

      txtDevId->SetTextBuf(szdevId);
      txtHrdLmt->SetTextBuf(szHrdLmt);
      txtLicInUse->SetTextBuf(szInUse);
      txtTmOut->SetTextBuf(szTmOut);
      txtHighestInUse->SetTextBuf(szHighestInUse);
   }
}

void __fastcall TFrmGetKeyInfo::ClearTextBoxes()
{
     txtDevId->SetTextBuf("FFFF");
     txtHrdLmt->SetTextBuf("");
     txtLicInUse->SetTextBuf("");
     txtTmOut->SetTextBuf("");
     txtHighestInUse->SetTextBuf("");

}
//---------------------------------------------------------------------------

